var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
/*
This file is part of the Notesnook project (https://notesnook.com/)

Copyright (C) 2023 Streetwriters (Private) Limited

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
import { forwardRef, useRef } from "react";
import { useEffect } from "react";
import { Button as RebassButton } from "@theme-ui/components";
const _Button = (props, forwardedRef) => {
    var _a;
    const { sx } = props, buttonProps = __rest(props, ["sx"]);
    const hoverBg = ((_a = sx === null || sx === void 0 ? void 0 : sx[":hover"]) === null || _a === void 0 ? void 0 : _a.bg) || "hover";
    const bg = (sx === null || sx === void 0 ? void 0 : sx.bg) || "unset";
    const buttonRef = useRef();
    useEffect(() => {
        if (!buttonRef.current)
            return;
        function onMouseDown(e) {
            e.preventDefault();
        }
        buttonRef.current.addEventListener("mousedown", onMouseDown, {
            passive: false,
            capture: true
        });
        return () => {
            var _a;
            (_a = buttonRef.current) === null || _a === void 0 ? void 0 : _a.removeEventListener("mousedown", onMouseDown, {
                capture: true
            });
        };
    }, []);
    return (_jsx(RebassButton, Object.assign({}, buttonProps, { sx: Object.assign(Object.assign({}, sx), { ":hover": { bg: [bg, hoverBg] }, ":active": { bg: hoverBg } }), ref: (ref) => {
            buttonRef.current = ref || undefined;
            if (typeof forwardedRef === "function")
                forwardedRef(ref);
            else if (forwardedRef)
                forwardedRef.current = ref;
        }, onClick: props.onClick })));
};
export const Button = forwardRef(_Button);
