import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
/*
This file is part of the Notesnook project (https://notesnook.com/)

Copyright (C) 2023 Streetwriters (Private) Limited

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
import { useRef } from "react";
import { Flex, Text } from "@theme-ui/components";
import { Icon } from "../../toolbar/components/icon";
import { Icons } from "../../toolbar/icons";
import { useToolbarLocation } from "../../toolbar/stores/toolbar-store";
import { Button } from "../button";
export function MenuButton(props) {
    const { item, isFocused, onMouseEnter, onMouseLeave, onClick } = props;
    const { title, key, icon, tooltip, isDisabled, isChecked, menu, modifier, styles } = item;
    const itemRef = useRef(null);
    const toolbarLocation = useToolbarLocation();
    const isBottom = toolbarLocation === "bottom";
    return (_jsx(Flex, Object.assign({ as: "li", sx: { flexShrink: 0, flexDirection: "column" }, onMouseEnter: onMouseEnter, onMouseLeave: onMouseLeave }, { children: _jsxs(Button, Object.assign({ id: key, "data-test-id": `MenuButton-${key}`, ref: itemRef, tabIndex: -1, variant: "menuitem", title: tooltip, disabled: isDisabled, onClick: (e) => onClick === null || onClick === void 0 ? void 0 : onClick(e.nativeEvent), sx: Object.assign(Object.assign({}, styles), { bg: isFocused && !isBottom ? "hover" : "transparent", display: "flex", alignItems: "center", justifyContent: "space-between", ":hover": {
                    bg: isBottom ? "transparent" : "hover"
                } }) }, { children: [_jsxs(Flex, Object.assign({ sx: { fontSize: "inherit", fontFamily: "inherit" } }, { children: [icon && (_jsx(Icon, { path: Icons[icon], color: "text", size: "medium", sx: { mr: 2 } })), _jsx(Text, Object.assign({ as: "span", variant: "body", sx: { fontSize: "inherit", fontFamily: "inherit" } }, { children: title }))] })), isChecked || menu || modifier ? (_jsxs(Flex, Object.assign({ sx: { ml: 4 } }, { children: [isChecked && _jsx(Icon, { path: Icons.check, size: "small" }), menu && _jsx(Icon, { path: Icons.chevronRight, size: "small" }), modifier && (_jsx(Text, Object.assign({ as: "span", sx: {
                                fontFamily: "body",
                                fontSize: "menu",
                                color: "fontTertiary"
                            } }, { children: modifier })))] }))) : null] }), key) })));
}
