import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
/*
This file is part of the Notesnook project (https://notesnook.com/)

Copyright (C) 2023 Streetwriters (Private) Limited

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
import React, { useContext } from "react";
export const PopupRendererContext = React.createContext(null);
export const EditorContext = React.createContext(null);
export class PopupRenderer extends React.Component {
    constructor() {
        super(...arguments);
        this.popupContainer = null;
        this.state = {
            popups: []
        };
        this.openPopup = (id, popup) => {
            if (!popup)
                return;
            this.setState((prev) => {
                return {
                    popups: [...prev.popups, { id, popup }]
                };
            });
        };
        this.closePopup = (id) => {
            this.setState((prev) => {
                const index = prev.popups.findIndex((p) => p.id === id);
                if (index <= -1)
                    return prev;
                const clone = prev.popups.slice();
                clone.splice(index, 1);
                return {
                    popups: clone
                };
            });
        };
    }
    isOpen(id) {
        var _a;
        return !!((_a = this.state.popups) === null || _a === void 0 ? void 0 : _a.find((popup) => popup.id === id));
    }
    render() {
        return (_jsxs(PopupRendererContext.Provider, Object.assign({ value: this }, { children: [this.props.children, _jsxs(EditorContext.Provider, Object.assign({ value: this.props.editor }, { children: [this.state.popups.map(({ id, popup: Popup }) => {
                            return _jsx(Popup, { id: id }, id);
                        }), _jsx("div", { id: "popup-container" })] }))] })));
    }
}
export function usePopupRenderer() {
    return useContext(PopupRendererContext);
}
