import { Fragment as _Fragment, jsx as _jsx } from "react/jsx-runtime";
import { Resizable } from "re-resizable";
import { Icon, Icons } from "../../toolbar";
export function Resizer(props) {
    const { editor, selected, onResize, width, height, children, handleColor, style } = props;
    if (!editor.isEditable)
        return _jsx(_Fragment, { children: children });
    return (_jsx(Resizable, Object.assign({ style: style, enable: {
            bottom: false,
            left: false,
            right: false,
            top: false,
            bottomLeft: false,
            bottomRight: selected,
            topLeft: false,
            topRight: false
        }, size: {
            height: height || "auto",
            width: width || "auto"
        }, className: "resizer", maxWidth: "100%", minWidth: 135, handleStyles: {
            bottomRight: {
                right: 0,
                bottom: 0,
                width: 30,
                height: 30,
                zIndex: 2
            }
        }, handleComponent: {
            bottomRight: (_jsx(Icon, { sx: {
                    width: 25,
                    height: 25
                }, path: Icons.resize, size: 25, color: handleColor || "black" }))
        }, onResizeStop: (_e, _direction, ref) => {
            try {
                onResize(ref.clientWidth, ref.clientHeight);
            }
            catch (_a) {
                // ignore
            }
        }, lockAspectRatio: true }, { children: children })));
}
