import { Node, Editor } from "@tiptap/core";
import { Attribute } from "@tiptap/core";
export declare type AttachmentType = "image" | "file" | "camera";
export interface AttachmentOptions {
    HTMLAttributes: Record<string, unknown>;
    onDownloadAttachment: (editor: Editor, attachment: Attachment) => boolean;
    onOpenAttachmentPicker: (editor: Editor, type: AttachmentType) => boolean;
    onPreviewAttachment: (editor: Editor, attachment: Attachment) => boolean;
}
export declare type AttachmentWithProgress = AttachmentProgress & Attachment;
export declare type Attachment = {
    hash: string;
    filename: string;
    type: string;
    size: number;
};
export declare type AttachmentProgress = {
    progress: number;
    type: "upload" | "download" | "encrypt";
    hash: string;
};
declare module "@tiptap/core" {
    interface Commands<ReturnType> {
        attachment: {
            openAttachmentPicker: (type: AttachmentType) => ReturnType;
            insertAttachment: (attachment: Attachment) => ReturnType;
            removeAttachment: () => ReturnType;
            downloadAttachment: (attachment: Attachment) => ReturnType;
            setAttachmentProgress: (progress: AttachmentProgress) => ReturnType;
            previewAttachment: (options: Attachment) => ReturnType;
        };
    }
}
export declare const AttachmentNode: Node<AttachmentOptions, any>;
export declare function getDataAttribute(name: string, def?: unknown | null): Partial<Attribute>;
