/*
This file is part of the Notesnook project (https://notesnook.com/)

Copyright (C) 2023 Streetwriters (Private) Limited

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
import { ListItem as TiptapListItem } from "@tiptap/extension-list-item";
import { onArrowUpPressed, onBackspacePressed } from "./commands";
export const ListItem = TiptapListItem.extend({
    addKeyboardShortcuts() {
        var _a;
        return Object.assign(Object.assign({}, (_a = this.parent) === null || _a === void 0 ? void 0 : _a.call(this)), { Tab: (props) => {
                var _a, _b;
                const { editor } = props;
                const { state } = editor;
                const { selection } = state;
                const { $from } = selection;
                if ($from.parent.type.name === "codeblock")
                    return false;
                return ((_b = (_a = this.parent) === null || _a === void 0 ? void 0 : _a.call(this)) === null || _b === void 0 ? void 0 : _b.Tab(props)) || false;
            }, Backspace: ({ editor }) => onBackspacePressed(editor, this.name, this.type), ArrowUp: ({ editor }) => onArrowUpPressed(editor, this.name, this.type) });
    }
});
