import { Node } from "@tiptap/core";
export interface WebClipOptions {
    HTMLAttributes: Record<string, unknown>;
}
export declare type WebClipAttributes = {
    fullscreen: boolean;
    src: string;
    html: string;
    title: string;
    hash: string;
    type: string;
    width?: string;
    height?: string;
};
declare module "@tiptap/core" {
    interface Commands<ReturnType> {
        webclip: {
            updateWebClip: (query: {
                hash?: string;
            }, options: {
                src: string;
            }) => ReturnType;
        };
    }
}
export declare const WebClipNode: Node<WebClipOptions, any>;
