/// <reference types="react" />
import { Theme } from "@notesnook/theme";
import { EditorOptions, getHTMLFromFragment } from "@tiptap/core";
import "./extensions";
import { AttachmentOptions } from "./extensions/attachment";
import { ImageOptions } from "./extensions/image";
import { OpenLinkOptions } from "./extensions/open-link";
import { WebClipOptions } from "./extensions/web-clip";
import { usePermissionHandler } from "./hooks/use-permission-handler";
import Toolbar from "./toolbar";
import { DownloadOptions } from "./utils/downloader";
declare type TiptapOptions = EditorOptions & Omit<AttachmentOptions, "HTMLAttributes"> & Omit<WebClipOptions, "HTMLAttributes"> & Omit<ImageOptions, "HTMLAttributes"> & OpenLinkOptions & {
    downloadOptions?: DownloadOptions;
    theme: Theme;
    isMobile?: boolean;
    isKeyboardOpen?: boolean;
    doubleSpacedLines?: boolean;
};
declare const useTiptap: (options?: Partial<TiptapOptions>, deps?: import("react").DependencyList) => import("./types").Editor | null;
export { type Fragment } from "prosemirror-model";
export { type Attachment, type AttachmentType } from "./extensions/attachment";
export * from "./extensions/react";
export * from "./toolbar";
export * from "./types";
export * from "./utils/word-counter";
export { useTiptap, Toolbar, usePermissionHandler, getHTMLFromFragment, type DownloadOptions };
