var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
/*
This file is part of the Notesnook project (https://notesnook.com/)

Copyright (C) 2023 Streetwriters (Private) Limited

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
import MDIIcon from "@mdi/react";
import { Flex } from "@theme-ui/components";
import { useTheme } from "@emotion/react";
function isSchemeColor(color, theme) {
    if (!theme || !theme.colors)
        return false;
    return color in theme.colors;
}
function MDIIconWrapper({ title, path, size = 24, color = "icon", stroke, rotate }) {
    const theme = useTheme();
    const themedColor = theme && isSchemeColor(color, theme)
        ? theme.colors[color]
        : color;
    return (_jsx(MDIIcon, { className: "icon", title: title, path: path, size: typeof size === "string"
            ? `${(theme === null || theme === void 0 ? void 0 : theme.iconSizes[size]) || 24}px`
            : `${size}px`, style: {
            strokeWidth: stroke || "0px",
            stroke: themedColor
        }, color: themedColor, spin: rotate }));
}
export function Icon(props) {
    const { sx, title, color, size, stroke, rotate, path } = props, restProps = __rest(props, ["sx", "title", "color", "size", "stroke", "rotate", "path"]);
    return (_jsx(Flex, Object.assign({ sx: Object.assign({ flexShrink: 0, justifyContent: "center", alignItems: "center" }, sx) }, restProps, { children: _jsx(MDIIconWrapper, { title: title, path: path, rotate: rotate, color: color, stroke: stroke, size: size }) })));
}
