var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
/*
This file is part of the Notesnook project (https://notesnook.com/)

Copyright (C) 2023 Streetwriters (Private) Limited

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
import { useRef } from "react";
import { Flex } from "@theme-ui/components";
import { Icons } from "../icons";
import { Icon } from "./icon";
import { ToolButton } from "./tool-button";
import { useToolbarLocation } from "../stores/toolbar-store";
import { Button } from "../../components/button";
import React from "react";
function _SplitButton(props) {
    const { children, onOpen, sx } = props, toolButtonProps = __rest(props, ["children", "onOpen", "sx"]);
    const ref = useRef(null);
    const toolbarLocation = useToolbarLocation();
    return (_jsxs(_Fragment, { children: [_jsxs(Flex, Object.assign({ ref: ref, sx: {
                    borderRadius: "default"
                } }, { children: [_jsx(ToolButton, Object.assign({}, toolButtonProps, { sx: Object.assign({ mr: 0, ":hover": { bg: "hover" } }, sx), toggled: false })), _jsx(Button, Object.assign({ sx: {
                            flexShrink: 0,
                            p: 0,
                            m: 0,
                            px: "3px",
                            bg: "bgSecondary",
                            ":hover": { bg: "hover" },
                            ":last-of-type": {
                                mr: 0
                            }
                        }, onClick: onOpen }, { children: _jsx(Icon, { path: toolbarLocation === "bottom" ? Icons.chevronUp : Icons.chevronDown, color: "text", size: "small", sx: { flexShrink: 0 } }) }))] })), children] }));
}
export const SplitButton = React.memo(_SplitButton, (prev, next) => {
    return (prev.toggled === next.toggled &&
        JSON.stringify(prev.sx) === JSON.stringify(next.sx) &&
        prev.children === next.children);
});
