import { Theme } from "@notesnook/theme";
import { DownloadOptions } from "../../utils/downloader";
export declare type ToolbarLocation = "top" | "bottom";
export declare type PopupRef = {
    id: string;
    group: string;
};
interface ToolbarState {
    theme?: Theme;
    setTheme: (theme?: Theme) => void;
    downloadOptions?: DownloadOptions;
    setDownloadOptions: (options?: DownloadOptions) => void;
    isKeyboardOpen: boolean;
    setIsKeyboardOpen: (isKeyboardOpen: boolean) => void;
    isMobile: boolean;
    openedPopups: Record<string, PopupRef | false | undefined>;
    setIsMobile: (isMobile: boolean) => void;
    toolbarLocation: ToolbarLocation;
    setToolbarLocation: (location: ToolbarLocation) => void;
    isPopupOpen: (popupId: string) => boolean;
    openPopup: (ref: PopupRef) => void;
    closePopup: (popupId: string) => void;
    closePopupGroup: (groupId: string, excluded: string[]) => void;
    closeAllPopups: () => void;
}
export declare const useToolbarStore: import("zustand").UseBoundStore<ToolbarState, import("zustand").StoreApi<ToolbarState>>;
export declare function useToolbarLocation(): ToolbarLocation;
export declare function useIsMobile(): boolean;
export declare const useTheme: (() => Theme | undefined) & {
    current: Theme | undefined;
};
export declare const useIsKeyboardOpen: (() => boolean) & {
    current: boolean;
};
export {};
